"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var severitylevel_1 = require("./severitylevel");
var appinsights_service_1 = require("./appinsights.service");
/**
 * App Insights Error Handler
 */
var AppInsightsErrorHandler = (function (_super) {
    __extends(AppInsightsErrorHandler, _super);
    function AppInsightsErrorHandler(appInsightsService) {
        var _this = _super.call(this, true) || this;
        _this.appInsightsService = appInsightsService;
        return _this;
    }
    AppInsightsErrorHandler.prototype.handleError = function (error) {
        this.appInsightsService.trackException(error, 'unhandled', null, null, severitylevel_1.SeverityLevel.Error);
        // delegate to the default handler
        _super.prototype.handleError.call(this, error);
    };
    return AppInsightsErrorHandler;
}(core_1.ErrorHandler));
AppInsightsErrorHandler = __decorate([
    core_1.Injectable(),
    __metadata("design:paramtypes", [appinsights_service_1.AppInsightsService])
], AppInsightsErrorHandler);
exports.AppInsightsErrorHandler = AppInsightsErrorHandler;
//# sourceMappingURL=errorhandler.js.map